<template>
  <div
    class="input-group"
    :class="{'input-group--error': companyDataErrors[fieldName] !== ''}"
  >
    <label class="input-label">
      {{label}}
    </label>
    <input
      class="input"
      @blur="handleBlur"
      v-model="fieldModel"
      :placeholder="placeholder"
      v-bind="aditionalProps"
    />
    <ErrorMessage v-bind:fieldName="fieldName" />
  </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex';
import ErrorMessage from './ErrorMessage.vue';

export default {
  name: "Input",
  components: {
    ErrorMessage,
  },
  props: {
    fieldName: String,
    label: String,
    placeholder: String,
    aditionalProps: {
      type: Object,
      default: () => ({
        type: 'text',
      }),
    },
  },
  methods: {
    ...mapActions(['updateCompanyField', 'validateField']),
    handleBlur() {
      this.validateField(this.fieldName);
    }
  },
  computed: {
    ...mapGetters(['companyData', 'companyDataErrors']),
    fieldModel: {
      get () {
        return this.companyData[this.fieldName];
      },
      set (fieldValue) {
        this.updateCompanyField({fieldName: this.fieldName, fieldValue});
      }
    }
  }
}
</script>

<style lang="scss" scoped>
  @import 'Styles/components/input.scss';
</style>

